#pragma once
#include "grbc/ext.h"
#include "grbc/generator.h"
#include "grbc/spec.h"
#include <map>
#include <sol/sol.hpp>
#include <string>
#include <unordered_map>
#include <vector>

struct GState {
  Platform current_platform{};
  sol::state lua;

  std::vector<GeneratorTask> tasks;
  std::vector<GeneratorTarget> targets;
  std::vector<Generator> generators;

  std::map<std::string, std::string> options;

  std::vector<Property> global_properties;

  std::unordered_map<std::string, Package> packages;

  std::vector<Extension> extensions;

  std::string global_compiler_flags = "";
  std::string global_linker_flags = " ";

  std::string ninja_output;

  static GState &get() {
    static GState state{};

    return state;
  }
};